//Планшет, Android и МК. Ракурс 3 (листинг 1), РА-7/2014
//Android-приложение: "IR Universal Remote"; кнопки 1, 2
#include <IRremote.h> //Библиотека функций ИК-управления
int RECV_PIN = 11;  //ИК-модуль подключается к порту D11
IRrecv irrecv(RECV_PIN); //Формирование структуры
decode_results results;  //Формирование структуры
//============Функция декодирования ПДУ=================
void pdu(decode_results *results) //Вкл=кн.1, Выкл=кн.2
{ unsigned long r = results->value; //Результат получен
  if (results->decode_type==NEC) //Протокол NEC
  { if ((r==0x61A000FF)||(r==0x20DF8877)||(r==0x1CE3807F)
      ||(r==0x2FD807F)) digitalWrite(13, HIGH); //Вкл.
    if ((r==0x61A0807F)||(r==0x20DF48B7)||(r==0x1CE340BF)
      ||(r==0x2FD40BF)) digitalWrite(13, LOW); //Выкл.
  } //Телевизоры: Insignia, LG, Sanyo, Toshiba, Vizio
  if (results->decode_type==SONY) //Протокол Sony
  { if (r==0x10) digitalWrite(13, HIGH); //Вкл. свет
    if (r==0x810) digitalWrite(13, LOW); //Выкл. свет
  } //Телевизоры: Sony
  if (results->decode_type==RC5) //Протокол RC-5
  { if ((r==0x1)||(r==0x801)) digitalWrite(13, HIGH);
    if ((r==0x802)||(r==0x2)) digitalWrite(13, LOW);
  } //Телевизоры: Magnavox, Philips
  if (results->decode_type==PANASONIC) //Прот. Panasonic
  { if (r==0x9000801) digitalWrite(13, HIGH); //Вкл.
    if (r==0x9008881) digitalWrite(13, LOW); //Выкл.
  } //Телевизоры: Panasonic, Panasonic 2
  if (results->decode_type==JVC) //Протокол JVC
  { if (r==0xC084) digitalWrite(13, HIGH); //Вкл. свет
    if (r==0xC044) digitalWrite(13, LOW); //Выкл. свет
  } //Телевизоры: JVC
  if (results->decode_type==UNKNOWN) //Неизвестный
  { if ((r==0xEC494D8D)||(r==0xE13DDA28)
      ||(r==0x885B30D5)) digitalWrite(13, HIGH); //Вкл.
    if ((r==0xC9B62F1F)||(r==0xAD586662)
      ||(r==0xE7E0CFB1)) digitalWrite(13, LOW); //Выкл.
  } //Телевизоры: Mitsubishi, Samsung, Sharp
  Serial.println(r, HEX); //Вывод цифр в терминал
} //================Начальные установки=================
void setup() //Блок инициализации
{ pinMode(13, OUTPUT); //Настройка порта D13 на выход
  Serial.begin(9600); //Настройка UART 9600 бод
  irrecv.enableIRIn(); //Старт декодирования
} //================Основная программа==================
void loop() //Вкл-выкл светодиода D13 кн. планшета 1, 2
{ if (irrecv.decode(&results)) //Успешное декодирование
  { pdu(&results); //Расшифровка протокола ПДУ, действие
    irrecv.resume();     //Ожидание следующей ИК-посылки
  }
} //Arduino-1.0.5-r2, длина кода 9428 байтов (29,3%)
